

/* 

window.courseware.getData(callback,key);  //用于获取数据
window.courseware.setData(data,callback,key);  //用于存储数据
var uploadUrl = window.courseware.uploadUrl();  //上传文件的路径
var uploadData = window.courseware.uploadData();  //上传文件必须要的参数 

*/

//对应模板的名称，这个可以不写，但是最好是能写上，同时开发多个模板的情况下如果不写这个，本地缓存可能会存在混乱
var key = "lexile_question";

new Vue({
  el: '.edit-data',
  created() {
    window.courseware.getData((data) => {
      this.data = data || {
        form_id: '',
        form_name: '',
        item_number: '',
        item_type: '',
        ims_id: '',
        word_count: '',
        passage_text: {
          text: '',
          audio: {
            url: '',
            name: '',
            size: '',
            duration: ''
          },
          image: {
            url: '',
          },
        },
        stem: {
          text: '',
          audio: {
            url: '',
            name: '',
            size: '',
            duration: ''
          },
          image: {
            url: '',
          },
        },
        options: []
      };
    }, key);
    console.log("========== data ==========")
    console.log(this.data)
    window['air'].getUploadCallback = (url, data) => {
      this.uploadUrl = url;
      this.uploadData = data;
    };
  },
  data() {
    return {
      data: [],
      uploadUrl: window.courseware.uploadUrl(),
      uploadData: window.courseware.uploadData(),
    }
  },
  methods: {
    handleAudioSuccess(res, file, obj) {
      // 假设上传接口返回的音频URL在 res.url 中
      obj.url = res.url;
      obj.name = file.name;
      // 计算文件大小
      obj.size = file.size;

      // 获取音频时长
      const audio = new Audio(res.url);
      audio.addEventListener('loadedmetadata', () => {
        obj.duration = audio.duration;
        this.save();
      });

      this.save();
    },

    // 播放/暂停音频
    togglePlay(index) {
      const audio = this.$refs['audio'][0];
      if (this.data.isPlaying) {
        audio.pause();
        this.data.isPlaying = false;
      } else {
        // 先停止其他正在播放的音频
        this.data.forEach((item, i) => {
          if (i !== index && item.isPlaying) {
            this.$refs['audio' + i][0].pause();
            item.isPlaying = false;
          }
        });
        audio.play();
        this.data.isPlaying = true;
      }
    },

    toggleOptionPlay(index, optionIndex) {
      const audio = this.$refs['audio' + index + '-' + optionIndex][0];
      if (this.data[index].options[optionIndex].isPlaying) {
        audio.pause();
        this.data[index].options[optionIndex].isPlaying = false;
      } else {
        // 先停止其他正在播放的音频
        this.data[index].options.forEach((item, i) => {
          if (i !== optionIndex && item.isPlaying) {
            this.$refs['audio' + index + '-' + i][0].pause();
            item.isPlaying = false;
          }
        });
        audio.play();
        this.data[index].options[optionIndex].isPlaying = true;
      }
    },

    // 音频播放结束
    audioEnded(index) {
      this.data[index].isPlaying = false;
    },

    audioOptionEnded(index, optionIndex) {
      this.data.options[optionIndex].isPlaying = false;
    },

    beforeAudioUpload(file) {
      const isAudio = file.type.startsWith('audio/');
      const isLt20M = file.size / 1024 / 1024 < 20;

      if (!isAudio) {
        this.$message.error('只能上传音频文件!');
        return false;
      }
      if (!isLt20M) {
        this.$message.error('音频大小不能超过 20MB!');
        return false;
      }
      return true;
    },
    save() {
      // 保存新增或修改的数据
      window.courseware.setData(this.data, () => {
        //保存数据也是异步的
        this.$message.success("实时保存成功");
      }, key);
    },
    addOption() {
      this.data.options.push({
        text: '',
        audio: {
          url: '',
          name: '',
          size: '',
          duration: ''
        },
        image: {
          url: '',
        },
        is_correct: false,
      });
      this.save();
    },
    deleteOption(optionIndex) {
      this.data.options.splice(optionIndex, 1);
      this.save();
    },
    // 图片上传成功的回调
    handleImageSuccess(res, file, obj) {
      // 假设上传接口返回的图片URL在 res.url 中
      obj.url = res.url;
      this.save();
    },
    handleOptionImageSuccess(res, file, obj) {
      obj.url = res.url;
      this.save();
    },

    // 图片上传前的验证
    beforeImageUpload(file) {
      const isImage = file.type.startsWith('image/');
      const isLt2M = file.size / 1024 / 1024 < 5;

      if (!isImage) {
        this.$message.error('只能上传图片文件!');
        return false;
      }
      if (!isLt2M) {
        this.$message.error('图片大小不能超过 2MB!');
        return false;
      }
      return true;
    },

    // 预览图片
    previewImage(url) {
      // 使用 Element UI 的 Image 组件预览
      const h = this.$createElement;
      this.$msgbox({
        title: '图片预览',
        message: h('img', {
          attrs: {
            src: url,
            style: 'max-width: 100%; max-height: 500px;'
          }
        }),
        showCancelButton: false,
        confirmButtonText: '关闭'
      });
    },
    removeImage(obj) {
      this.$confirm('确定要删除这张图片吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        obj.url = '';
        this.save();
        this.$message({
          type: 'success',
          message: '删除成功!'
        });
      }).catch(() => { });
    },
    removeOptionImage(obj) {
      obj.url = '';
      this.save();
    }
  },
  computed: {
  }
});
